package com.jpabugreport;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.TestExecutionListeners;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.support.DependencyInjectionTestExecutionListener;
import org.springframework.test.context.support.DirtiesContextTestExecutionListener;
import org.springframework.test.context.transaction.TransactionalTestExecutionListener;

import com.jpabugreport.Contractor;
import com.jpabugreport.Employee;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration("/applicationContext.xml")
@TestExecutionListeners({ DependencyInjectionTestExecutionListener.class, DirtiesContextTestExecutionListener.class,
	TransactionalTestExecutionListener.class })
public class JpaBugReportTest {

	private static interface MyRepo extends JpaRepository<Contractor, Employee.PrimaryKey> {
	}

	private static final String SSN = "111223333";
	private static final int BADGE_NUMBER = 45;

	@Autowired
	private MyRepo sqlRepo;

	@Before
	public void setUp() {
		sqlRepo.save(makeContractor());
	}

	@After
	public void tearDown() {
		sqlRepo.delete(new Employee.PrimaryKey(SSN, BADGE_NUMBER));
	}

	@Test
	public void repoGet() {
		sqlRepo.findOne(new Employee.PrimaryKey(SSN, BADGE_NUMBER));
	}

	private Contractor makeContractor() {
		Contractor contractor = new Contractor();
		contractor.setSsn(SSN);
		contractor.setContractExpiration(System.currentTimeMillis());
		contractor.setBadgeNumber(BADGE_NUMBER);
		return contractor;
	}
}
